﻿@model PagedResult<EmployeeGetListResDto>

@{
    ViewData["Title"] = "Index";
    Layout = "~/Views/Shared/_Layout.cshtml";
}

<h1>Index</h1>

@if (ViewBag.Count != null)
{
    <p>
        Inserted rows count: @ViewBag.Count
    </p>
}

<p>
    <a asp-action="AddFile">Add New File</a>
</p>
<div class="table-responsive border rounded p-1">
    <table id="example" class="table table-striped table-bordered dt-responsive nowrap" width="100%" cellspacing="0">
        <thead>
            <tr>
                <th>
                    Id
                </th>
                <th>
                    Surname
                </th>
                <th>
                    Forename
                </th>
                <th>
                    PayrollNumber
                </th>
                <th>
                    DateOfBirth
                </th>
                <th>
                    Telephone
                </th>
                <th>
                    Mobile
                </th>
                <th>
                    Address
                </th>
                <th>
                    Address2
                </th>
                <th>
                    Postcode
                </th>
                <th>
                    EmailHome
                </th>
                <th>
                    StartDate
                </th>
                <th></th>
            </tr>
        </thead>
    </table>
</div>

<script type="text/javascript">

    // formating DateTime
    (function (factory) {
        "use strict";

        if (typeof define === 'function' && define.amd) {
            // AMD
            define(['jquery'], function ($) {
                return factory($, window, document);
            });
        }
        else if (typeof exports === 'object') {
            // CommonJS
            module.exports = function (root, $) {
                if (!root) {
                    root = window;
                }

                if (!$) {
                    $ = typeof window !== 'undefined' ?
                        require('jquery') :
                        require('jquery')(root);
                }

                return factory($, root, root.document);
            };
        }
        else {
            // Browser
            factory(jQuery, window, document);
        }
    }
        (function ($, window, document) {


            $.fn.dataTable.render.moment = function (from, to, locale) {
                // Argument shifting
                if (arguments.length === 1) {
                    locale = 'en';
                    to = from;
                    from = 'YYYY-MM-DD';
                }
                else if (arguments.length === 2) {
                    locale = 'en';
                }

                return function (d, type, row) {
                    if (!d) {
                        return type === 'sort' || type === 'type' ? 0 : d;
                    }

                    var m = window.moment(d, from, locale, true);

                    // Order and type get a number value from Moment, everything else
                    // sees the rendered value
                    return m.format(type === 'sort' || type === 'type' ? 'x' : to);
                };
            };


        }));

    $(document).ready(function () {

        $('#example').DataTable({
            "order": [[1, 'asc']],
            "processing": true, // for show progress bar
            "serverSide": true, // for process server side
            "filter": true, // this is for disable filter (search box)
            "orderMulti": false, // for disable multiple column at once
            "searching": true,
            "ajax": {
                "url": '@Url.Action("GetList")',
                "type": "GET",
                "datatype": "json",
                "data": function (dtp) {
                    var searchValue = dtp.search.value;
                    dtp.search = searchValue;

                    dtp.orderColumn = dtp.order[0]?.column;
                    dtp.orderDir = dtp.order[0]?.dir;

                    return dtp;
                }
            },
            "columns": [
                { "data": "id", "autoWidth": true, "className": "text-center", "defaultContent": "" },
                { "data": "surname", "autoWidth": true, "className": "text-center", "defaultContent": "" },
                { "data": "forename", "autoWidth": true, "className": "text-center", "defaultContent": "" },
                { "data": "payrollNumber", "autoWidth": true, "className": "text-center", "defaultContent": "" },
                { "data": "dateOfBirth", "autoWidth": true, "className": "text-center", "defaultContent": "", "render": $.fn.dataTable.render.moment('YYYY-M-DDTHH:mm:ss', 'DD.MM.YYYY') },
                { "data": "telephone", "autoWidth": true, "className": "text-center", "defaultContent": "" },
                { "data": "mobile", "autoWidth": true, "className": "text-center", "defaultContent": "" },
                { "data": "address", "autoWidth": true, "className": "text-center", "defaultContent": "" },
                { "data": "address2", "autoWidth": true, "className": "text-center", "defaultContent": "" },
                { "data": "postcode", "autoWidth": true, "className": "text-center", "defaultContent": "" },
                { "data": "emailHome", "autoWidth": true, "className": "text-center", "defaultContent": "" },
                { "data": "startDate", "autoWidth": true, "className": "text-center", "defaultContent": "", "render": $.fn.dataTable.render.moment('YYYY-M-DDTHH:mm:ss', 'DD.MM.YYYY') },
                {
                    "data": "", "autoWidth": true, "style": "display: flex;", "className": "text-center", "defaultContent": "",
                    "render": function (data, type, full, meta) { return `<a href="/Employee/Details/${full.id}" class='btn btn-primary' style="margin-left:1px;margin-right:1px">Details</a><a class="btn btn-info" style="margin-left:1px;margin-right:1px" href="/Employee/Edit/${full.id}">Edit</a><a href="/Employee/Delete/${full.id}" style="margin-left:1px;margin-right:1px" class='btn btn-danger'>Delete</a>`; }
                }
            ]
        });
    });
</script>
